# gam on all the data

rm(list=ls(all=TRUE))
library(lme4)
# The effect of language mode
library(lmerTest) # The new package for confidence interval and anova()
library(lattice)
library(ggplot2)
library(ez)
library(mgcv) #gam
library('itsadug') #smooth plotting functions for gam
source('Wieling2014plotting.R') # additiona plotting functiosns provided by Martijn Wieling 2014
source('Wieling2014compareML.R') # model comparison


# load("lexicaldecision_JN.RData")
# data.byItem.JN=data.frame(rwdata.byItem,Lanmod="JN")
# data.byPar.JN=data.frame(rwdata.byPar,Lanmod="JN")
# data.prumed.JN=data.frame(rwdata.prumed,Lanmod="JN")
# load("lexicaldecision_SC.RData")
# data.byItem.SC=data.frame(rwdata.byItem,Lanmod="SC")
# data.byPar.SC=data.frame(rwdata.byPar,Lanmod="SC")
# data.prumed.SC=data.frame(rwdata.prumed,Lanmod="SC")
# load("lexicaldecision_BJ.RData")
# data.byItem.BJ=data.frame(rwdata.byItem,Lanmod="BJ")
# data.byPar.BJ=data.frame(rwdata.byPar,Lanmod="BJ")
# data.prumed.BJ=data.frame(rwdata.prumed,Lanmod="BJ")
# 
# 
# data.byItem.dual=rbind(data.byItem.JN,data.byItem.SC)
# data.byPar.dual=rbind(data.byPar.JN,data.byPar.SC)
# data.prumed.dual=rbind(data.prumed.JN,data.prumed.SC)
# # remove the participant with a different accent
# data.prumed.dual=data.prumed.dual[-which(data.prumed.dual$participant==46),]
# # ModeOrder
# ModeOrder_table=read.table("ModeOrder.txt")
# colnames(ModeOrder_table)=c("participant","ModeOrder")
# data.prumed.dual=merge(data.prumed.dual,ModeOrder_table,by="participant",all.x=T)
# Block=rep(NA, nrow(data.prumed.dual))
# Block[which(data.prumed.dual$Lanmod=="JN" & data.prumed.dual$ModeOrder=="JN_SC")]="first"
# Block[which(data.prumed.dual$Lanmod=="SC" & data.prumed.dual$ModeOrder=="JN_SC")]="second"
# Block[which(data.prumed.dual$Lanmod=="JN" & data.prumed.dual$ModeOrder=="SC_JN")]="second"
# Block[which(data.prumed.dual$Lanmod=="SC" & data.prumed.dual$ModeOrder=="SC_JN")]="first"
# data.prumed.dual=data.frame(data.prumed.dual,Block)
# # Through descriptive statistics, we notice that the 10 JM dominant participants should be excluded
# data.prumed.SCdominant=data.prumed.dual[-which(data.prumed.dual$participant=="104"|
#                                                  data.prumed.dual$participant=="73"|
#                                                  data.prumed.dual$participant=="69"|
#                                                  data.prumed.dual$participant=="68"|
#                                                  data.prumed.dual$participant=="65"|
#                                                  data.prumed.dual$participant=="64"|
#                                                  data.prumed.dual$participant=="61"|
#                                                  data.prumed.dual$participant=="57"|
#                                                  data.prumed.dual$participant=="51"|
#                                                  data.prumed.dual$participant=="49"
# ),]
# # # Split data.prumed.SCdominant according to Block and combine each with data.prumed.BJ
# # data.prumed.first= rbind(data.prumed.SCdominant
# #                          [which(data.prumed.SCdominant$Block=="first"),1:17],
# #                          data.prumed.BJ)
# # data.prumed.second= rbind(data.prumed.SCdominant
# #                           [which(data.prumed.SCdominant$Block=="second"),1:17],
# #                           data.prumed.BJ)
# ##############################################
# # Trial.general: take the order in both blocks into consideration
# # Adjust Trial of the second block (+54)
# Trial.general= as.numeric(as.character(data.prumed.SCdominant$Trial))
# Trial.general[which(data.prumed.SCdominant$Block=="second")]=
#   Trial.general[which(data.prumed.SCdominant$Block=="second")]+54
# Trial.general.crl=scale(Trial.general)
# # transform the other variables
# Trial.crl=scale(as.numeric(as.character(data.prumed.SCdominant$Trial)))
# meanSimi.crl=scale(as.numeric(as.character(data.prumed.SCdominant$meanSimi)))
# LogRT=log(data.prumed.SCdominant$RT)
# data.prumed.SCdominant=data.frame(data.prumed.SCdominant,
#                                   LogRT,
#                                   Trial.crl,
#                                   meanSimi.crl,
#                                   Trial.general,
#                                   Trial.general.crl)
# 
# # adjust the structure of BJ prumed data
# data.prumed.BJ=data.frame(data.prumed.BJ,
#                           ModeOrder=rep(NA,nrow(data.prumed.BJ)),
#                           Block=rep(NA,nrow(data.prumed.BJ)),
#                           LogRT=log(data.prumed.BJ$RT),
#                           Trial.crl=scale(as.numeric(as.character(data.prumed.BJ$Trial))),
#                           meanSimi.crl=scale(as.numeric(as.character(data.prumed.BJ$meanSimi))),
#                           Trial.general=as.numeric(as.character(data.prumed.BJ$Trial)),
#                           Trial.general.crl=scale(as.numeric(as.character(data.prumed.BJ$Trial)))
#                           )
# # combine JM-SC data with BJ data
# data.prumed.bothgroups= rbind(data.prumed.SCdominant,
#                            data.prumed.BJ)
# ###############################################
# # simi,WFreq,LanMod are crossed with each other
# # participant is crossed with LanMod and nested under ModOrder; 
# # commonID (item) is nested under Simi:WFreq
# # Trial covariate with LanMod. BJ has bigger Trial number because they were presented with the whole list
# data.prumed.bothgroups=data.frame(data.prumed.bothgroups,
#                                   Lanmod_Block=paste(data.prumed.bothgroups$Lanmod,data.prumed.bothgroups$Block,sep="_"))
# ########################################
# save(data.prumed.bothgroups,file="lexicaldecision_both_forGAM.RData")

load("lexicaldecision_both_forGAM.RData")
##########################################
# (0) # without factorial predictors and the random factors
m_0 = bam(LogRT ~ s(meanSimi.crl), 
                     data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_0)
# plot
par(mfrow=c(1,2)) # 2 plots in one window
plot(m_0, rug=F, shade=T, seWithMean=T,
     ylab='centralized similarity', main='m_0: partial effect')
abline(h = 0, lty = 1) # horizontal lines
ic = m_0$coef["(Intercept)"] # intercept from model
plot(m_0, rug=F, shade=T, seWithMean=T, shift = ic,
     ylab='centralized similarity', main='m_0: shifted by intercept')
abline(h = 0, lty = 1) # horizontal lines
# examine: p should not be low, k' should not be close to edf
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_0) # note that there will be plots. If any problem make adjustments
# k too low

# (1) sensitivity varies by participant: adding by-participant random slopes of meanSimi.crl 
m_1 = bam(LogRT ~ s(meanSimi.crl) 
          +s(meanSimi.crl,participant,bs='fs',m=1),
          data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_1)
# plot
par(mfrow=c(1,2)) # 2 plots in one window
plot(m_1,select=1,shade=T,
     main = 'm_1: partial effect of centralized similarity') # plotting for contour partial
plot(m_1,select=2, ylim=c(-4,4)) # means plotting for participant variation
# examine: p should not be low, k' should not be close to edf
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_1) # note that there will be plots. If any problem make adjustments
# k too low

# (2) adding by = Lanmod
m_2 = bam(LogRT ~ s(meanSimi.crl,by=Lanmod) +Lanmod
          +s(meanSimi.crl,participant,bs='fs',m=1),
          data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_2)
# plot
par(mfrow=c(1,3)) # 2 plots in one window
plot_smooth(m_2, view='meanSimi.crl', cond=list(Lanmod="JN"),
            col='red',main="JM",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_2, view='meanSimi.crl', cond=list(Lanmod="SC"),
            col='blue',main="SC",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_2, view='meanSimi.crl', cond=list(Lanmod="BJ"),
            col='grey',main="BJ",ylim=c(6.6,7),
            rm.ranef=TRUE)
out_JNBJ=plot_diff(m_2, view='meanSimi.crl', 
                   comp=list(Lanmod=c("BJ","JN")),
                   ylim=c(-0.2,0.2),
                   main="JM-BJ") # 
out_SCBJ=plot_diff(m_2, view='meanSimi.crl', 
                   comp=list(Lanmod=c("BJ", "SC")),
                   ylim=c(-0.2,0.2),
                   main="SC-BJ") # 
out_JNSC=plot_diff(m_2, view='meanSimi.crl',
                   comp=list(Lanmod=c("JN", "SC")),
                   ylim=c(-0.2,0.2),
                   main="SC-JM")
find_difference(out_JNBJ$est, out_JNBJ$se, f=1.96, xVals=out_JNBJ$xVals)
find_difference(out_SCBJ$est, out_SCBJ$se, f=1.96, xVals=out_SCBJ$xVals)
find_difference(out_JNSC$est, out_JNSC$se, f=1.96, xVals=out_JNSC$xVals)
#no difference is sig. here
#plotSmooths(m_2, "meanSimi", "Lanmod", colors=c('red','green','blue'),
#            eegAxis=F,legendScale=1,dropRanef='participant') 
## plotSmooths is a customized function by Wieling, which puts the effects in complete model context
#plotDiff(m_2, "meanSimi", "Lanmod", eegAxis=F,
#         main="difference curve") # examine: p should not be low, k' should not be close to edf
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_2) # note that there will be plots. If any problem make adjustments
# k too low

# (3) adding by = WFreq
m_3 = bam(LogRT ~ s(meanSimi.crl,by=Lanmod) +s(meanSimi.crl,by=WFreq) 
          +Lanmod+WFreq
          +s(meanSimi.crl,participant,bs='fs',m=1),
          data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_3)
# plot
par(mfrow=c(2,3)) # 2 plots in one window
plot_smooth(m_3, view='meanSimi.crl', cond=list(Lanmod="JN",WFreq="h"),
            col='red',main="JM high frequency words by bilinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_3, view='meanSimi.crl', cond=list(Lanmod="SC",WFreq="h"),
            col='blue',main="SC high frequency words by bilinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_3, view='meanSimi.crl', cond=list(Lanmod="BJ",WFreq="h"),
            col='grey',main="SC high frequency words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_3, view='meanSimi.crl', cond=list(Lanmod="JN",WFreq="l"),
            col='red',main="JM low frequency words by bilinguals",ylim=c(6,8),
            rm.ranef=TRUE)
plot_smooth(m_3, view='meanSimi.crl', cond=list(Lanmod="SC",WFreq="l"),
            col='blue',main="SC low frequency words by bilinguals",ylim=c(6,8),
            rm.ranef=TRUE)
plot_smooth(m_3, view='meanSimi.crl', cond=list(Lanmod="BJ",WFreq="l"),
            col='grey',main="SC low frequency words by monolinguals",ylim=c(6,8),
            rm.ranef=TRUE)
# split by freq
par(mfrow=c(1,2))
plotSmooths(m_3, "meanSimi.crl", "Lanmod", col=c("red","blue","black"),
            cond=list(WFreq="h"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.0),legendScale=1,dropRanef="participant",
            main="high-frequency") #wieling's
plotSmooths(m_3, "meanSimi.crl", "Lanmod", col=c("red","blue","black"),
            cond=list(WFreq="l"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6,9),legendScale=1,dropRanef="participant",
            main="low-frequency") #wieling's
# diff
par(mfrow=c(1,3))
out_JNBJ=plot_diff(m_3, view='meanSimi.crl',
                   comp=list(Lanmod=c("BJ","JN")),
                   ylim=c(-0.2,0.2),
                   main="JM-BJ") # 
out_SCBJ=plot_diff(m_3, view='meanSimi.crl', 
                   comp=list(Lanmod=c("BJ", "SC")),
                   ylim=c(-0.2,0.2),
                   main="SC-BJ") # 
out_JNSC=plot_diff(m_3, view='meanSimi.crl',
                   comp=list(Lanmod=c("JN", "SC")),
                   ylim=c(-0.2,0.2),
                   main="SC-JM")
find_difference(out_JNBJ$est, out_JNBJ$se, f=1.96, xVals=out_JNBJ$xVals)
find_difference(out_SCBJ$est, out_SCBJ$se, f=1.96, xVals=out_SCBJ$xVals)
find_difference(out_JNSC$est, out_JNSC$se, f=1.96, xVals=out_JNSC$xVals)
# plot_diff equivalent to plotDiff e.g., in the following format
# plotDiff(m_3, "meanSimi.crl", "Lanmod",list("BJ","JN") ,eegAxis=F,ylim=c(-0.2,0.2),
#         main="difference curve") 
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_3) # note that there will be plots. If any problem make adjustments
# k alright

# (4) try improving the model by adding commonID into the random factor structure
m_4 = bam(LogRT ~ s(meanSimi.crl,by=Lanmod) +s(meanSimi.crl,by=WFreq) 
          +Lanmod+WFreq
          +s(meanSimi.crl,participant,bs='fs',m=1)
          +s(commonID,bs='re'),
          data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_4)
# plot
par(mfrow=c(2,3)) # 
plot_smooth(m_4, view='meanSimi.crl', cond=list(Lanmod="JN",WFreq="h"),
            col='red',main="JM high frequency words by bilinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_4, view='meanSimi.crl', cond=list(Lanmod="SC",WFreq="h"),
            col='blue',main="SC high frequency words by bilinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_4, view='meanSimi.crl', cond=list(Lanmod="BJ",WFreq="h"),
            col='grey',main="SC high frequency words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_4, view='meanSimi.crl', cond=list(Lanmod="JN",WFreq="l"),
            col='red',main="JM low frequency words by bilinguals",ylim=c(6,8),
            rm.ranef=TRUE)
plot_smooth(m_4, view='meanSimi.crl', cond=list(Lanmod="SC",WFreq="l"),
            col='blue',main="SC low frequency words by bilinguals",ylim=c(6,8),
            rm.ranef=TRUE)
plot_smooth(m_4, view='meanSimi.crl', cond=list(Lanmod="BJ",WFreq="l"),
            col='grey',main="SC low frequency words by monolinguals",ylim=c(6,8),
            rm.ranef=TRUE)
# split by freq
par(mfrow=c(1,2)) # 2 plots in one window
plotSmooths(m_4, "meanSimi.crl", "Lanmod", col=c("red","blue","yellow"),
            cond=list(WFreq="h"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
            main="high-frequency") #wieling's
plotSmooths(m_4, "meanSimi.crl", "Lanmod", col=c("red","blue","yellow"),
            cond=list(WFreq="l"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
            main="low-frequency") #wieling's
# diff
par(mfrow=c(1,3)) # 2 plots in one window
out_JNBJ=plot_diff(m_4, view='meanSimi.crl',
                   comp=list(Lanmod=c("BJ","JN")),
                   ylim=c(-0.2,0.2),
                   main="JM-BJ") # 
out_SCBJ=plot_diff(m_4, view='meanSimi.crl', 
                   comp=list(Lanmod=c("BJ", "SC")),
                   ylim=c(-0.2,0.2),
                   main="SC-BJ") # 
out_JNSC=plot_diff(m_4, view='meanSimi.crl',
                   comp=list(Lanmod=c("JN", "SC")),
                   ylim=c(-0.2,0.2),
                   main="SC-JM")
find_difference(out_JNBJ$est, out_JNBJ$se, f=1.96, xVals=out_JNBJ$xVals)
find_difference(out_SCBJ$est, out_SCBJ$se, f=1.96, xVals=out_SCBJ$xVals)
find_difference(out_JNSC$est, out_JNSC$se, f=1.96, xVals=out_JNSC$xVals)
# plot_diff equivalent to plotDiff e.g., in the following format
# plotDiff(m_4, "meanSimi.crl", "Lanmod",list("BJ","JN") ,eegAxis=F,ylim=c(-0.2,0.2),
#         main="difference curve") 
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_4) # note that there will be plots. If any problem make adjustments
# k alright
AIC(m_3)-AIC(m_4)
compareML(m_3,m_4)

# (5a) try improving the model by adding Block into a separated smooth
m_5 = bam(LogRT ~ s(meanSimi.crl,by=Lanmod)
          +s(meanSimi.crl,by=WFreq) 
          +s(meanSimi.crl,by=Block)
          +Lanmod+WFreq+Block
          +s(meanSimi.crl,participant,bs='fs',m=1)
          +s(commonID,bs='re'),
          data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_5)
# plot Lanmod*Block
par(mfrow=c(2,2)) # 
plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="JN",Block="first"),
            col='red',main="JM words by bilinguals 1st block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="SC",Block="first"),
            col='blue',main="SC words by bilinguals 1st block",ylim=c(6.6,7),
            rm.ranef=TRUE)
# plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="BJ",Block="first"),
#             col='grey',main="SC high frequency words by monolinguals no block",ylim=c(6.6,7),
#             rm.ranef=TRUE)
plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="JN",Block="second"),
            col='red',main="JM words by bilinguals 2nd block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="SC",Block="second"),
            col='blue',main="SC words by bilinguals 2nd block",ylim=c(6.6,7),
            rm.ranef=TRUE)
# plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="BJ",Block="second"),
#             col='grey',main="SC low frequency words by monolinguals no block",ylim=c(6,8),
#             rm.ranef=TRUE)
plot_smooth(m_5, view='meanSimi.crl', cond=list(Lanmod="SC"),
            col='grey',main="SC words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
# split by Wfreq*Block
par(mfrow=c(2,2)) # 2 plots in one window
plotSmooths(m_5, "meanSimi.crl", "Lanmod", col=c("red","blue","yellow"),
            cond=list(WFreq="h",Block="first"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
            main="high-frequency first block") #wieling's
plotSmooths(m_5, "meanSimi.crl", "Lanmod", col=c("red","blue","yellow"),
            cond=list(WFreq="l",Block="first"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
            main="low-frequency first block") #wieling's
plotSmooths(m_5, "meanSimi.crl", "Lanmod", col=c("red","blue","yellow"),
            cond=list(WFreq="h",Block="second"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
            main="high-frequency second block") #wieling's
plotSmooths(m_5, "meanSimi.crl", "Lanmod", col=c("red","blue","yellow"),
            cond=list(WFreq="l",Block="second"),legendPos="topright",useLegend=F,
            eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
            main="low-frequency second block") #wieling's
# # diff  "BJ" not included in the fitting because of rank deficiency
# par(mfrow=c(1,3)) # 2 plots in one window
# out_JNBJ=plot_diff(m_5, view='meanSimi.crl',
#                    comp=list(Lanmod=c("BJ","JN")),
#                    ylim=c(-0.2,0.2),
#                    main="JM-BJ") # 
# out_SCBJ=plot_diff(m_5, view='meanSimi.crl', 
#                    comp=list(Lanmod=c("BJ", "SC")),
#                    ylim=c(-0.2,0.2),
#                    main="SC-BJ") # 
# out_JNSC=plot_diff(m_5, view='meanSimi.crl',
#                    comp=list(Lanmod=c("JN", "SC")),
#                    ylim=c(-0.2,0.2),
#                    main="SC-JM")
# find_difference(out_JNBJ$est, out_JNBJ$se, f=1.96, xVals=out_JNBJ$xVals)
# find_difference(out_SCBJ$est, out_SCBJ$se, f=1.96, xVals=out_SCBJ$xVals)
# find_difference(out_JNSC$est, out_JNSC$se, f=1.96, xVals=out_JNSC$xVals)
# plot_diff equivalent to plotDiff e.g., in the following format
# plotDiff(m_5, "meanSimi.crl", "Lanmod",list("BJ","JN") ,eegAxis=F,ylim=c(-0.2,0.2),
#         main="difference curve") 
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_5) # note that there will be plots. If any problem make adjustments
# k alright
AIC(m_4)-AIC(m_5)
compareML(m_4,m_5) # not better

# (5b) try improving the model by adding Block
# BJ has no Block, rank deficiency
# create a new factorial predictor as the comibination of Block & Lanmod
m_5b = bam(LogRT ~ s(meanSimi.crl,by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(meanSimi.crl,participant,bs='fs',m=1)
           +s(commonID,bs='re'),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_5b)
# plot Lanmod*Block
par(mfrow=c(2,3)) # 
plot_smooth(m_5b, view='meanSimi.crl', cond=list(Lanmod_Block="JN_first"),
            col='red',main="JM words by bilinguals in the first block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5b, view='meanSimi.crl', cond=list(Lanmod_Block="SC_first"),
            col='blue',main="SC words by bilinguals in the first block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5b, view='meanSimi.crl', cond=list(Lanmod_Block="BJ_NA"),
            col='grey',main="SC words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5b, view='meanSimi.crl', cond=list(Lanmod_Block="JN_second"),
            col='red',main="JM words by bilinguals in the second block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5b, view='meanSimi.crl', cond=list(Lanmod_Block="SC_second"),
            col='blue',main="SC words by bilinguals in the second block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5b, view='meanSimi.crl', cond=list(Lanmod_Block="BJ_NA"),
            col='grey',main="SC words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
# split by Wfreq*Block
par(mfrow=c(2,1)) # 2 plots in one window
plotSmooths(m_5b, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
            cond=list(WFreq="h"),
            legendPos="topright",useLegend=T,
            eegAxis=F,ylim=c(6.6,7),legendScale=1,dropRanef="participant",
            main="high-frequency") #wieling's
plotSmooths(m_5b, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
            cond=list(WFreq="l"),
            legendPos="topright",useLegend=T,
            eegAxis=F,ylim=c(6.6,7),legendScale=1,dropRanef="participant",
            main="low-frequency") #wieling's
# plotSmooths(m_5b, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
#             cond=list(WFreq="h",
#                       "Lanmod_Block"="SC_second",
#                       "Lanmod_Block"="JM_second",
#                       "Lanmod_Block"="BJ_NA"),
#             legendPos="topright",useLegend=T,
#             eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
#             main="high-frequency") #wieling's
# plotSmooths(m_5b, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
#             cond=list(WFreq="l",                   
#                       "Lanmod_Block"="SC_second",
#                       "Lanmod_Block"="JM_second",
#                       "Lanmod_Block"="BJ_NA"),
#             legendPos="topright",useLegend=F,
#             eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
#             main="low-frequency, second block") #wieling's
# diff
par(mfrow=c(3,2)) # 2 plots in one window
out_JNBJ1=plot_diff(m_5b, view='meanSimi.crl',
                   comp=list(Lanmod_Block=c("BJ_NA","JN_first")),
                   ylim=c(-0.2,0.2),
                   main="JM frist block-BJ") # 
out_SCBJ1=plot_diff(m_5b, view='meanSimi.crl', 
                   comp=list(Lanmod_Block=c("BJ_NA", "SC_first")),
                   ylim=c(-0.2,0.2),
                   main="SC first block-BJ") # 
out_JNBJ2=plot_diff(m_5b, view='meanSimi.crl',
                    comp=list(Lanmod_Block=c("BJ_NA","JN_second")),
                    ylim=c(-0.2,0.2),
                    main="JM second block-BJ") # 
out_SCBJ2=plot_diff(m_5b, view='meanSimi.crl', 
                    comp=list(Lanmod_Block=c("BJ_NA", "SC_second")),
                    ylim=c(-0.2,0.2),
                    main="SC second block-BJ") # 
out_JNSC1=plot_diff(m_5b, view='meanSimi.crl',
                   comp=list(Lanmod_Block=c("JN_first", "SC_first")),
                   ylim=c(-0.2,0.2),
                   main="SC-JM first block")
out_JNSC2=plot_diff(m_5b, view='meanSimi.crl',
                    comp=list(Lanmod_Block=c("JN_second", "SC_second")),
                    ylim=c(-0.2,0.2),
                    main="SC-JM second block")

find_difference(out_JNBJ1$est, out_JNBJ1$se, f=1.96, xVals=out_JNBJ1$xVals)
find_difference(out_JNBJ2$est, out_JNBJ2$se, f=1.96, xVals=out_JNBJ2$xVals)
find_difference(out_SCBJ1$est, out_SCBJ1$se, f=1.96, xVals=out_SCBJ1$xVals)
find_difference(out_SCBJ2$est, out_SCBJ2$se, f=1.96, xVals=out_SCBJ2$xVals)
find_difference(out_JNSC1$est, out_JNSC1$se, f=1.96, xVals=out_JNSC1$xVals)
find_difference(out_JNSC2$est, out_JNSC2$se, f=1.96, xVals=out_JNSC2$xVals)
# plot_diff equivalent to plotDiff e.g., in the following format
# plotDiff(m_5b, "meanSimi.crl", "Lanmod",list("BJ","JN") ,eegAxis=F,ylim=c(-0.2,0.2),
#         main="difference curve") 
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_5b) # note that there will be plots. If any problem make adjustments
# k alright
AIC(m_4)-AIC(m_5b)
compareML(m_4,m_5b)

# (5c) Similar to 5b. replace commonID with StimuliID
m_5c = bam(LogRT ~ s(meanSimi.crl,by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(meanSimi.crl,participant,bs='fs',m=1)
           +s(StimuliID,bs='re'),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
# Warning message:
#In gam.side(sm, X, tol = .Machine$double.eps^0.5) :
#  model has repeated 1-d smooths of same variable.
summary(m_5c)
# plot Lanmod*Block
par(mfrow=c(2,3)) # 
plot_smooth(m_5c, view='meanSimi.crl', cond=list(Lanmod_Block="JN_first"),
            col='red',main="JM words by bilinguals in the first block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5c, view='meanSimi.crl', cond=list(Lanmod_Block="SC_first"),
            col='blue',main="SC words by bilinguals in the first block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5c, view='meanSimi.crl', cond=list(Lanmod_Block="BJ_NA"),
            col='grey',main="SC words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5c, view='meanSimi.crl', cond=list(Lanmod_Block="JN_second"),
            col='red',main="JM words by bilinguals in the second block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5c, view='meanSimi.crl', cond=list(Lanmod_Block="SC_second"),
            col='blue',main="SC words by bilinguals in the second block",ylim=c(6.6,7),
            rm.ranef=TRUE)
plot_smooth(m_5c, view='meanSimi.crl', cond=list(Lanmod_Block="BJ_NA"),
            col='grey',main="SC words by monolinguals",ylim=c(6.6,7),
            rm.ranef=TRUE)
# split by Wfreq*Block
par(mfrow=c(2,1)) # 2 plots in one window
plotSmooths(m_5c, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
            cond=list(WFreq="h"),
            legendPos="topright",useLegend=T,
            eegAxis=F,ylim=c(6.6,7),legendScale=1,dropRanef="participant",
            main="high-frequency") #wieling's
plotSmooths(m_5c, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
            cond=list(WFreq="l"),
            legendPos="topright",useLegend=T,
            eegAxis=F,ylim=c(6.6,7),legendScale=1,dropRanef="participant",
            main="low-frequency") #wieling's
# plotSmooths(m_5c, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
#             cond=list(WFreq="h",
#                       "Lanmod_Block"="SC_second",
#                       "Lanmod_Block"="JM_second",
#                       "Lanmod_Block"="BJ_NA"),
#             legendPos="topright",useLegend=T,
#             eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
#             main="high-frequency") #wieling's
# plotSmooths(m_5c, "meanSimi.crl", "Lanmod_Block", col=c("red","blue","yellow"),
#             cond=list(WFreq="l",                   
#                       "Lanmod_Block"="SC_second",
#                       "Lanmod_Block"="JM_second",
#                       "Lanmod_Block"="BJ_NA"),
#             legendPos="topright",useLegend=F,
#             eegAxis=F,ylim=c(6.6,7.5),legendScale=1,dropRanef="participant",
#             main="low-frequency, second block") #wieling's
# diff
par(mfrow=c(3,2)) # 2 plots in one window
out_JNBJ1=plot_diff(m_5c, view='meanSimi.crl',
                    comp=list(Lanmod_Block=c("BJ_NA","JN_first")),
                    ylim=c(-0.2,0.2),
                    main="JM frist block-BJ") # 
out_SCBJ1=plot_diff(m_5c, view='meanSimi.crl', 
                    comp=list(Lanmod_Block=c("BJ_NA", "SC_first")),
                    ylim=c(-0.2,0.2),
                    main="SC first block-BJ") # 
out_JNBJ2=plot_diff(m_5c, view='meanSimi.crl',
                    comp=list(Lanmod_Block=c("BJ_NA","JN_second")),
                    ylim=c(-0.2,0.2),
                    main="JM second block-BJ") # 
out_SCBJ2=plot_diff(m_5c, view='meanSimi.crl', 
                    comp=list(Lanmod_Block=c("BJ_NA", "SC_second")),
                    ylim=c(-0.2,0.2),
                    main="SC second block-BJ") # 
out_JNSC1=plot_diff(m_5c, view='meanSimi.crl',
                    comp=list(Lanmod_Block=c("JN_first", "SC_first")),
                    ylim=c(-0.2,0.2),
                    main="SC-JM first block")
out_JNSC2=plot_diff(m_5c, view='meanSimi.crl',
                    comp=list(Lanmod_Block=c("JN_second", "SC_second")),
                    ylim=c(-0.2,0.2),
                    main="SC-JM second block")

find_difference(out_JNBJ1$est, out_JNBJ1$se, f=1.96, xVals=out_JNBJ1$xVals)
find_difference(out_JNBJ2$est, out_JNBJ2$se, f=1.96, xVals=out_JNBJ2$xVals)
find_difference(out_SCBJ1$est, out_SCBJ1$se, f=1.96, xVals=out_SCBJ1$xVals)
find_difference(out_SCBJ2$est, out_SCBJ2$se, f=1.96, xVals=out_SCBJ2$xVals)
find_difference(out_JNSC1$est, out_JNSC1$se, f=1.96, xVals=out_JNSC1$xVals)
find_difference(out_JNSC2$est, out_JNSC2$se, f=1.96, xVals=out_JNSC2$xVals)
# plot_diff equivalent to plotDiff e.g., in the following format
# plotDiff(m_5c, "meanSimi.crl", "Lanmod",list("BJ","JN") ,eegAxis=F,ylim=c(-0.2,0.2),
#         main="difference curve") 
# (Wieling 2014) double k if higher k is needed, but do not set it too high, i.e. max 1/2 unique time points
gam.check(m_5c) # note that there will be plots. If any problem make adjustments
# k alright
AIC(m_5b)-AIC(m_5c)
compareML(m_5b,m_5c)
save(m_5c,file="temp_lexicaldecisionGAM_m5c.RData")

# #(6a) Try improving the model by including Trial.general.crl: by participant surface of meanSimi.crl,Trial.general.crl
# m_6a = bam(LogRT ~ s(meanSimi.crl,by=Lanmod_Block)
#            +s(meanSimi.crl,by=WFreq) 
#            +Lanmod_Block+WFreq
#            +s(meanSimi.crl,Trial.general.crl,participant,bs='fs',m=1)
#            +s(commonID,bs='re'),
#            data=data.prumed.bothgroups, gc.level=2, method='ML')
# # memory exceeded

# (6b)Try improving the model by including Trial.general.crl: by Lanmod_Block surface of meanSimi.crl,Trial.general.crl
# m_6b = bam(LogRT ~ te(meanSimi.crl,Trial.general.crl,d=c(1,1),by=Lanmod_Block)
#            +s(meanSimi.crl,by=WFreq) 
#            +Lanmod_Block+WFreq
#            +s(meanSimi.crl,participant,bs='fs',m=1)
#            +s(Trial.general.crl,commonID,bs='fs',m=1),
#            data=data.prumed.bothgroups, gc.level=2, method='ML')
# summary(m_6b)
# AIC(m_5b)-AIC(m_6b) #not as good as m_5b
# par(mfrow=c(1,1))
# pvisgam(m_6b, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=1,
#          color='topo', main='m_6b: Lanmod_BlockBJ_NA sig.')
# par(mfrow=c(2,2))
# pvisgam(m_6b, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=2,
#          color='topo', main='m_6b: Lanmod_BlockJN_first insig.',
#          ylim=c(min(data.prumed.bothgroups$Trial.general.crl),0))
# pvisgam(m_6b, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=3,
#          color='topo', main='m_6b: Lanmod_BlockJN_second insig.',
#          ylim=c(0,max(data.prumed.bothgroups$Trial.general.crl)))
# pvisgam(m_6b, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=4,
#          color='topo', main='m_6b: Lanmod_BlockSC_first insig.',
#          ylim=c(min(data.prumed.bothgroups$Trial.general.crl),0))
# pvisgam(m_6b, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=5,
#          color='topo', main='m_6b: Lanmod_BlockSC_second sig.',
#          ylim=c(0,max(data.prumed.bothgroups$Trial.general.crl)))
# # When Block = first, there is no data for Trial.general.crl>0
# # When Block = second, there is no data for Trial.general.crl<0
# # Thus half of the plots are useless
# # diff  Lanmod_BlockBJ_NA v.s.Lanmod_BlockSC_second 
# # I want SC_second-BJ_NA
# par(mfrow=c(1,2))
# out_SC2nd_h=plot_diff2(m_6b, view=c('meanSimi.crl','Trial.general.crl'), 
#            comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
#            cond=list(WFreq="h"),
#            plotCI=T,n.grid=50,main="high freq SC_second - BJ_NA"
#             ) # seems reversed, and title wrong
# out_SC2nd_l=plot_diff2(m_6b, view=c('meanSimi.crl','Trial.general.crl'), 
#                      comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
#                      cond=list(WFreq="l"),
#                      plotCI=T,n.grid=50,main="low freq SC_second - BJ_NA") # seems reversed, and title wrong
# # # this is equivalent, just looks better
# # plotDiff2D(m_6b, "meanSimi.crl", "Trial.general.crl", "Lanmod_Block",
# #            list("BJ_NA","SC_second"), plotCI=T) #unable to set ylim

# (6c)Try improving the model by replacing commonID with StimuliID
m_6c = bam(LogRT ~ te(meanSimi.crl,Trial.general.crl,d=c(1,1),by=Lanmod_Block)
          +s(meanSimi.crl,by=WFreq) 
          +Lanmod_Block+WFreq
          +s(meanSimi.crl,participant,bs='fs',m=1)
          +s(Trial.general.crl,StimuliID,bs='fs',m=1),
          data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_6c)
AIC(m_5c)-AIC(m_6c) # only different from 5c in the use of Trial.general.crl, slightly improved
AIC(m_6b)-AIC(m_6c) # only different from 6b in the use of StimuliID, improved
compareML(m_5c,m_6c)
par(mfrow=c(1,1))
pvisgam(m_6c, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=1,
         color='topo', main='m_6c: Lanmod_BlockBJ_NA sig.')
par(mfrow=c(2,2))
pvisgam(m_6c, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=2,
         color='topo', main='m_6c: Lanmod_BlockJN_first insig.',
         ylim=c(min(data.prumed.bothgroups$Trial.general.crl),0))
pvisgam(m_6c, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=3,
         color='topo', main='m_6c: Lanmod_BlockJN_second insig.',
         ylim=c(0,max(data.prumed.bothgroups$Trial.general.crl)))
pvisgam(m_6c, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=4,
         color='topo', main='m_6c: Lanmod_BlockSC_first insig.',
         ylim=c(min(data.prumed.bothgroups$Trial.general.crl),0))
pvisgam(m_6c, plot.type='contour', view=c('meanSimi.crl','Trial.general.crl'), select=5,
         color='topo', main='m_6c: Lanmod_BlockSC_second sig.',
         ylim=c(0,max(data.prumed.bothgroups$Trial.general.crl)))
# When Block = first, there is no data for Trial.general.crl>0
# When Block = second, there is no data for Trial.general.crl<0
# Thus half of the plots are useless
# diff  Lanmod_BlockBJ_NA v.s.Lanmod_BlockSC_second 
# I want SC_second-BJ_NA
par(mfrow=c(1,2))
out_SC2nd_h=plot_diff2(m_6c, view=c('meanSimi.crl','Trial.general.crl'), 
                       comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="high freq SC_second - BJ_NA") # seems reversed, and title wrong
out_SC2nd_l=plot_diff2(m_6c, view=c('meanSimi.crl','Trial.general.crl'), 
                       comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
                       cond=list(WFreq="l"),
                       plotCI=T,n.grid=50,main="low freq SC_second - BJ_NA") # seems reversed, and title wrong
# # this is equivalent, just looks better
# plotDiff2D(m_6c, "meanSimi.crl", "Trial.general.crl", "Lanmod_Block",
#            list("BJ_NA","SC_second"), plotCI=T) #unable to set ylim
save(m_6c,file="temp_lexicaldecisionGAM_m6c.RData")
# by meanSimi.crl StimuliID random term is impossible, since each StitmuliID has an unique meanSimi.crl value

# # (6d)Try not including Trial.general.crl in the fixed smooths and see if it is worse than 6c
# m_6d = bam(LogRT ~ te(meanSimi.crl,d=c(1,1),by=Lanmod_Block)
#            +s(meanSimi.crl,by=WFreq) 
#            +Lanmod_Block+WFreq
#            +s(meanSimi.crl,participant,bs='fs',m=1)
#            +s(Trial.general.crl,StimuliID,bs='fs',m=1),
#            data=data.prumed.bothgroups, gc.level=2, method='ML')
# summary(m_6d)
# AIC(m_5c)-AIC(m_6d) # only different from 5c in the use of Trial.general.crl
# AIC(m_6c)-AIC(m_6d) # 6c has Trial.general.crl in the fixed smooths
# compareML(m_5c,m_6d) #
# # 6c better
# replace 
#(6e) replace meanSimi.crl with Trial.general.crl in the random term
m_6e = bam(LogRT ~ te(meanSimi.crl,Trial.general.crl,d=c(1,1),by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(Trial.general.crl,participant,bs='fs',m=1)
           +s(Trial.general.crl,StimuliID,bs='fs',m=1),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
AIC(m_6c)-AIC(m_6e)
compareML(m_6c,m_6e)
#m_6e much better
save(m_6e,file="temp_lexicaldecisionGAM_m6e.RData")


# (7a)Try replacing Trial.general.crl with Trial.crl (in both the fixed and the random smooths)
m_7a = bam(LogRT ~ te(meanSimi.crl,Trial.crl, d=c(1,1),by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(meanSimi.crl,participant,bs='fs',m=1)
           +s(Trial.crl,StimuliID,bs='fs',m=1),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_7a)
AIC(m_5c)-AIC(m_7a) # 5c did not use Trial.crl
AIC(m_6c)-AIC(m_7a) # 6c has Trial.general.crl instead of Trial.crl
compareML(m_5c,m_7a)
compareML(m_6c,m_7a)
# m_7a better
gam.check(m_7a) # check the residuals. OK
acf(resid(m_7a), main='ACF of res model1') # check the acf. OK
save(m_7a,file="temp_lexicaldecisionGAM_m7a.RData")
# (7c) try adding s(Trial.crl,participant,bs='fs',m=1)
m_7c = bam(LogRT ~ te(meanSimi.crl,Trial.crl, d=c(1,1),by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(meanSimi.crl,participant,bs='fs',m=1)
           +s(Trial.crl,participant,bs='fs',m=1)
           +s(Trial.crl,StimuliID,bs='fs',m=1),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
smry_7c=summary(m_7c)
AIC(m_7a)-AIC(m_7c) # 7a did not have s(Trial.crl,participant,bs='fs',m=1)
compareML(m_7a,m_7c)
# #Reached total allocation of 3986Mb: see help(memory.size)
# used linux swap 20G succeeded, m_7c better
save(m_7c,file="temp_lexicaldecisionGAM_m7c.RData")
save(smry_7c,file="temp_lexicaldecisionGAM_smry7c.RData")
m_7d = bam(LogRT ~ te(meanSimi.crl,Trial.crl, d=c(1,1),by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(Trial.crl,participant,bs='fs',m=1)
           +s(Trial.crl,StimuliID,bs='fs',m=1),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_7d)
AIC(m_7a)-AIC(m_7d) # 7a did not have s(Trial.crl,participant,bs='fs',m=1)and has s(meanSimi.crl,participant,bs='fs',m=1) 
compareML(m_7a,m_7d)
save(m_7d,file="temp_lexicaldecisionGAM_m7d.RData")
#plot
par(mfrow=c(1,1))
pvisgam(m_7a, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=1,
         xlab="scaled similarity (z-transformed)",ylab="scaled trial order (z-transformed)",
         color='topo', main='Tested in SC by monolinguals (control)')
par(mfrow=c(2,2))
par(mar=c(1.5,4,4,1)) #bottom,left,top, right
pvisgam(m_7a, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=2,
         ylab="",
         color='topo', main=NULL)
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(1.5,1,4,4))
pvisgam(m_7a, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=3,
         xlab="",
         color='topo', main=NULL)
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("JM", side=4, line=0.5,font = 2)
par(mar=c(4,4,1,1))
pvisgam(m_7a, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=4,
         xlab="",ylab="",
         color='topo', main=NULL)
par(mar=c(4,1,1,4))
pvisgam(m_7a, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=5,
         xlab="",
         color='topo', main=NULL)
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses to Tonal Similarity and Trial Order", side = 3, line = -1, outer = TRUE,font=2)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# Trial.crl is scaled for each Block. Thus each Block is assumed as equivalent to the whole BJ test
# diff  Lanmod_BlockBJ_NA v.s.Lanmod_BlockSC_second 
# I want SC_second-BJ_NA
par(mfrow=c(2,2))
par(mar=c(1.5,3,4,2)) #bottom,left,top, right
out_JN1st_h=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_first","BJ_NA")),
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(1.5,1,4,4))
out_JN2nd_h=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_second","BJ_NA")),
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="")
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("JM", side=4, line=0.5, font = 2)
par(mar=c(3,3,2,2))
out_SC1st_h=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_first","BJ_NA")),
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
par(mar=c(3,1,2,4))
out_SC2nd_h=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
mtext("SC", side=4, line=0.5, font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=2)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# compare conditions
# 2nd - 1st
par(mfrow=c(2,1))
par(mar=c(1.5,3,4,3)) #bottom,left,top, right
out_JN_1stVS2nd=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                         comp=list(Lanmod_Block=c("JN_second","JN_first")),
                         cond=list(WFreq="h"),
                         plotCI=T,n.grid=50,main="")
mtext("JM", side=4, line=0.5, font = 2)
par(mar=c(3,3,1,3))
out_SC_1stV2nd=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                          comp=list(Lanmod_Block=c("SC_second","SC_first")),
                          cond=list(WFreq="h"),
                          plotCI=T,n.grid=50,main="")
mtext("SC", side=4, line=0.5,font =2)
mtext("2nd Block - 1st Block", side = 3, line = -2, outer = TRUE,font=2)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# SC -JM
par(mfrow=c(1,2))
par(mar=c(2.5,4,3,1)) #bottom,left,top, right
out_SCvsJN_1st=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                           comp=list(Lanmod_Block=c("SC_first","JN_first")),
                           cond=list(WFreq="h"),
                           plotCI=T,n.grid=50,main="")
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(2.5,1,3,4)) #bottom,left,top, right
out_SCvsJN_2nd=plot_diff2(m_7a, view=c('meanSimi.crl','Trial.crl'), 
                          comp=list(Lanmod_Block=c("SC_second","JN_second")),
                          cond=list(WFreq="h"),
                          plotCI=T,n.grid=50,main="")
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("bilinguals: SC - JM", side = 3, line = -2, outer = TRUE,font=2)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)
# example slices
# 1. (1) at the beginning of the block, the increase of similarity facilitates lexical access
par(mfrow=c(2,2))
# JNfirst_BJ
par(mar=c(1.5,4,4,1)) #bottom,left,top, right
slice_JNfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
               cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
     type='l',xlab="",
     main=NULL,
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("1st Block", side=3, line=0.5,font = 2)
# JNsecond_BJ
par(mar=c(1.5,1,4,4))
slice_JNsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("JM", side=4, line=0.5,font = 2)
# SCfirst_BJ
par(mar=c(4,4,1,1))
slice_SCfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# SCsecond_BJ
par(mar=c(4,1,1,4))
slice_SCsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=2)
mtext("In the beginning trials, scaled trial order = -1.5", side = 3, line = -2, outer = TRUE,font=2)
mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# (2) the responses times to the most similar (nearly identical) translation equivalents increase with the accumulation of trials
par(mfrow=c(2,2))
# JNfirst_BJ
par(mar=c(1.5,4,4,1)) #bottom,left,top, right
slice_JNfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
                                 cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# JNsecond_BJ
par(mar=c(1.5,1,4,4))
slice_JNsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
                                  cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# SCfirst_BJ
par(mar=c(4,4,1,1))
slice_SCfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
                                 cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# SCsecond_BJ
par(mar=c(4,1,1,4))
slice_SCsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
                                  cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=2)
mtext("To the most similar translation equivalents, scaled similarity = 2.25", side = 3, line = -2, outer = TRUE,font=2)
mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled trial order (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# 2. JM and SC common in the first blocks:
# 2.(1) The effect of tonal similarity effect reverses with the increase of trials
par(mfrow=c(2,1))
# JNfirst_BJ
par(mar=c(1.5,3,4,3)) #bottom,left,top, right
slice_JNfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("JM", side=4, line=0.5,font = 2)
# SCfirst_BJ
par(mar=c(4,3,1,3))
slice_SCfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=0.5,font =2)
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=2)
mtext("In the final trials, scaled trial order = 1.5, 1st Block", side = 3, line = -2, outer = TRUE,font=2)
mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# 2.(2)the responses times to the less similar translation equivalents decrease with the accumulation of trials
par(mfrow=c(2,1))
# JNfirst_BJ
par(mar=c(1.5,3,4,3)) #bottom,left,top, right
slice_JNfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
                                 cond=list(meanSimi.crl=-1,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("JM", side=4, line=0.5,font = 2)
# SCfirst_BJ
par(mar=c(4,3,1,3))
slice_SCfirst_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
                                 cond=list(meanSimi.crl=-1,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses to tonal similarity and trial order", side = 3, line = -1, outer = TRUE,font=2)
mtext("To the least similar translation equivalents, scaled similarity = -1,1st Block", side = 3, line = -2, outer = TRUE,font=2)
mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled trial order (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)
# 2nd block
par(mfrow=c(2,1))
# JNsecond_BJ
par(mar=c(1.5,3,4,3)) #bottom,left,top, right
slice_JNsecond_BJ= get_difference(m_7a,ccomp=list(Lanmod_Block=c('JN_second','BJ_NA')),
                                  cond=list(meanSimi.crl=-1.5,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("JM", side=4, line=0.5,font = 2)
# SCsecond_BJ
par(mar=c(4,3,1,3))
slice_SCsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
                                  cond=list(meanSimi.crl=-1.5,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses to tonal similarity and trial order", side = 3, line = -1, outer = TRUE,font=2)
mtext("To the least similar translation equivalents, scaled similarity = -1.5,2nd Block", side = 3, line = -2, outer = TRUE,font=2)
mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled trial order (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# 3. The second block
# (1) Tested in the non-dominant language JM, the sensitivity to interlingual tonal similarity is lost after switching 
# (2) Tested in the dominant language SC, trial-independent discontinuous response to tonal similarity emerged 
par(mfrow=c(2,1))
# JNsecond_BJ
par(mar=c(1.5,3,4,3)) #bottom,left,top, right
slice_JNsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("JM", side=4, line=0.5,font = 2)
# SCsecond_BJ
par(mar=c(4,3,1,3))
slice_SCsecond_BJ= get_difference(m_7a,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
     type='l',xlab="",
     main="",
     ylab="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=2)
mtext("In the final trials, scaled trial order = 1.5, 2nd Block", side = 3, line = -2, outer = TRUE,font=2)
mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)
##### 
#same for 7c
# yaxt='n' can remove y axis, ann=FALSE can remove all annotations
#plot
par(mfrow=c(1,1))
par(mar=c(4,5,4,3)) #bottom,left,top, right
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=1,
         labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
         xlab="scaled similarity (z-transformed)",ylab="scaled trial order (z-transformed)",
         color='topo', main='Tested in SC by monolinguals (control)') # only labcex, cex.main are working.
par(mfrow=c(2,2))
par(mar=c(1.5,4,4,2)) #bottom,left,top, right
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=2,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
         ylab="",xaxt='n',
         color='topo', main=NULL) 
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(1.5,1,4,4))
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=3,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
         xlab="",yaxt='n',xaxt='n',
         color='topo', main=NULL)
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("JM", side=4, line=0.5,font = 2)
par(mar=c(4,4,1,2))
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=4,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
         xlab="",ylab="",
         color='topo', main=NULL)
par(mar=c(4,1,1,4))
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=5,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
         xlab="",yaxt='n',
         color='topo', main=NULL)
mtext("SC", side=4, line=0.5,font =2)
mtext("Bilinguals' Responses to Tonal Similarity and Trial Order", side = 3, line = -1, outer = TRUE,font=3)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# another plot for the same subplots, without big main title on the top and on the left (but on the right), also without titles of each subplots
par(mfrow=c(2,2))
par(mar=c(0.5,2,2,1)) #bottom,left,top, right
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=2,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
        ylab="",xaxt='n',yaxt='n',
        color='topo', main=NULL) 
par(mar=c(0.5,0,2,4))
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=3,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
        xlab="",yaxt='n',xaxt='n',
        color='topo', main=NULL)
axis(4,cex.axis=1.5,labels = FALSE)
mtext("JM", side=4, line=1,font = 2)
par(mar=c(4,2,0,1))
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=4,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
        xlab="",ylab="",yaxt='n',
        color='topo', main=NULL)
mtext("1st Block", side=1, line=2,font = 2)
par(mar=c(4,0,0,4))
pvisgam(m_7c, plot.type='contour', view=c('meanSimi.crl','Trial.crl'), select=5,
        labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,
        xlab="",yaxt='n',
        color='topo', main=NULL)
axis(4,cex.axis=1.5,labels = FALSE)
mtext("2nd Block", side=1, line=2,font = 2)
mtext("SC", side=4, line=1,font =2)
mtext("scaled trial order (z-transformed)", side = 4, line=-1, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# JN/SC_first/second - BJ_NA
# Trial.crl is scaled for each Block. Thus each Block is assumed as equivalent to the whole BJ test
# e.g. diff  Lanmod_BlockBJ_NA v.s.Lanmod_BlockSC_second 
# e.g. I want SC_second-BJ_NA
par(mfrow=c(2,2))
par(mar=c(1.5,3,4,2)) #bottom,left,top, right
out_JN1st_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_first","BJ_NA")),
                       cond=list(WFreq="h"),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',yaxt='n',ylab ='',
                       plotCI=T,n.grid=50,main="") 
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(1.5,1,4,4))
out_JN2nd_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_second","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xaxt='n',
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="")
axis(4,cex.axis=1.5,labels = FALSE)
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("JM", side=4, line=0.5, font = 2)
par(mar=c(4,3,1,2))
out_SC1st_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_first","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xlab="",ylab='',
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
par(mar=c(4,1,1,4))
out_SC2nd_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xlab="",
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
axis(4,cex.axis=1.5,labels = FALSE)
mtext("SC", side=4, line=0.5, font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=3)
mtext("scaled trial order (z-transformed)", side = 4, line=-1, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# the same JN/SC_first/second - BJ_NA for fig 5a
par(mfrow=c(2,2))
par(mar=c(1.5,4,4,1)) #bottom,left,top, right
out_JN1st_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_first","BJ_NA")),
                       cond=list(WFreq="h"),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',ylab ='',
                       plotCI=T,n.grid=50,main="") 
lines(x=c(-1.5,2.4),y=c(-1.5,-1.5),lwd=3,col='red')
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(1.5,2,4,3))
out_JN2nd_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_second","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xaxt='n',
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="")
lines(x=c(-1.5,2.4),y=c(-1.5,-1.5),lwd=3,col='red')
#axis(4,cex.axis=1.5,labels = FALSE)
mtext("2nd Block", side=3, line=0.5,font = 2)
#mtext("JM", side=4, line=0.5, font = 2)
par(mar=c(4,4,1,1))
out_SC1st_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_first","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xlab="",ylab='',
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
lines(x=c(-1.5,2.4),y=c(-1.5,-1.5),lwd=3,col='red')
par(mar=c(4,2,1,3))
out_SC2nd_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xlab="",
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
lines(x=c(-1.5,2.4),y=c(-1.5,-1.5),lwd=3,col='red')
#axis(4,cex.axis=1.5,labels = FALSE)
#mtext("SC", side=4, line=0.5, font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=3)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# the same JN/SC_first/second - BJ_NA for fig 6b
par(mfrow=c(2,2))
par(mar=c(1.5,4,4,1)) #bottom,left,top, right
out_JN1st_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_first","BJ_NA")),
                       cond=list(WFreq="h"),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',ylab ='',
                       plotCI=T,n.grid=50,main="") 
lines(x=c(-1.5,2.4),y=c(1.5,1.5),lwd=3,col='red')
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(1.5,2,4,3))
out_JN2nd_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("JN_second","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xaxt='n',
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="")
lines(x=c(-1.5,2.4),y=c(1.5,1.5),lwd=3,col='red')
#axis(4,cex.axis=1.5,labels = FALSE)
mtext("2nd Block", side=3, line=0.5,font = 2)
#mtext("JM", side=4, line=0.5, font = 2)
par(mar=c(4,4,1,1))
out_SC1st_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_first","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xlab="",ylab='',
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
lines(x=c(-1.5,2.4),y=c(1.5,1.5),lwd=3,col='red')
par(mar=c(4,2,1,3))
out_SC2nd_h=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                       comp=list(Lanmod_Block=c("SC_second","BJ_NA")),
                       labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xlab="",
                       cond=list(WFreq="h"),
                       plotCI=T,n.grid=50,main="") 
lines(x=c(-1.5,2.4),y=c(1.5,1.5),lwd=3,col='red')
#axis(4,cex.axis=1.5,labels = FALSE)
#mtext("SC", side=4, line=0.5, font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=3)
mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)


# compare conditions
# 2nd - 1st
par(mfrow=c(2,1))
par(mar=c(0.5,3,2,3)) #bottom,left,top, right
out_JN_1stVS2nd=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                           comp=list(Lanmod_Block=c("JN_second","JN_first")),
                           cond=list(WFreq="h"),
                           labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xaxt='n',
                           plotCI=T,n.grid=50,main="")
mtext("JM", side=2, line=0.5, font = 2)
par(mar=c(3.5,3,0,3))
out_SC_1stV2nd=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                          comp=list(Lanmod_Block=c("SC_second","SC_first")),
                          labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt='n',xlab="",
                          cond=list(WFreq="h"),
                          plotCI=T,n.grid=50,main="")
mtext("SC", side=2, line=0.5,font =2)
mtext("2nd Block - 1st Block", side = 2, line = -1, outer = TRUE,font=3)
# mtext("scaled trial order (z-transformed)", side = 2, line=-2, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# SC -JM
par(mfrow=c(1,2))
par(mar=c(2.5,2,3,1)) #bottom,left,top, right
out_SCvsJN_1st=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                          comp=list(Lanmod_Block=c("SC_first","JN_first")),
                          cond=list(WFreq="h"),
                          labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',yaxt='n',ylab ='',
                          plotCI=T,n.grid=50,main="")
mtext("1st Block", side=3, line=0.5,font = 2)
par(mar=c(2.5,0,3,4)) #bottom,left,top, right
out_SCvsJN_2nd=plot_diff2(m_7c, view=c('meanSimi.crl','Trial.crl'), 
                          comp=list(Lanmod_Block=c("SC_second","JN_second")),
                          cond=list(WFreq="h"),
                          labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',yaxt='n',xlab="",ylab='',
                          plotCI=T,n.grid=50,main="")
axis(4,cex.axis=1.5,labels = FALSE)
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("bilinguals: SC - JM", side = 3, line = -1, outer = TRUE,font=3)
#mtext("scaled trial order (z-transformed)", side = 2, line=-1, outer = TRUE, font=3)
#mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# example slices
# 1. (1) at the beginning of the block, the increase of similarity facilitates lexical access
par(mfrow=c(2,2))
# JNfirst_BJ
par(mar=c(1.5,4,4,1)) #bottom,left,top, right
slice_JNfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
     type='l',
     main=NULL,
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',yaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("1st Block", side=3, line=0.5,font = 2)
mtext("JM", side=2, line=2,font = 2)
# JNsecond_BJ
par(mar=c(1.5,1,4,4))
slice_JNsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
     type='l',
     main="",
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt='n',yaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
axis(4,cex.axis=1.5)
mtext("2nd Block", side=3, line=0.5,font = 2)

# SCfirst_BJ
par(mar=c(4,4,1,1))
slice_SCfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
     type='l',
     main="",
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=2, line=2,font =2)
# SCsecond_BJ
par(mar=c(4,1,1,4))
slice_SCsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=-1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
     type='l',
     main="",
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
axis(4,cex.axis=1.5)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=3)
mtext("In the beginning trials, scaled trial order = -1.5", side = 3, line = -2, outer = TRUE,font=3)
mtext("difference in estimated Log RT", side = 4, line=-1.5, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)

# # (2) the responses times to the most similar (nearly identical) translation equivalents increase with the accumulation of trials
# par(mfrow=c(2,2))
# # JNfirst_BJ
# par(mar=c(1.5,4,4,1)) #bottom,left,top, right
# slice_JNfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
#                                  cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("1st Block", side=3, line=0.5,font = 2)
# # JNsecond_BJ
# par(mar=c(1.5,1,4,4))
# slice_JNsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
#                                   cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("2nd Block", side=3, line=0.5,font = 2)
# mtext("JM", side=4, line=0.5,font = 2)
# # SCfirst_BJ
# par(mar=c(4,4,1,1))
# slice_SCfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
#                                  cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# # SCsecond_BJ
# par(mar=c(4,1,1,4))
# slice_SCsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
#                                   cond=list(meanSimi.crl=2.25,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("SC", side=4, line=0.5,font =2)
# mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=2)
# mtext("To the most similar translation equivalents, scaled similarity = 2.25", side = 3, line = -2, outer = TRUE,font=2)
# mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
# mtext("scaled trial order (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# 2. JM and SC common in the first blocks:
# 2.(1) The effect of tonal similarity effect reverses with the increase of trials
par(mfrow=c(2,1))
# JNfirst_BJ
par(mar=c(1.5,5,4,1)) #bottom,left,top, right
slice_JNfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block= c('JN_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
     type='l',
     main="",
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("1st Block", side=3, line=0.5,font = 2)
mtext("JM", side=2, line=4,font = 2)
# SCfirst_BJ
par(mar=c(4,5,1,1))
slice_SCfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
                                 cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
     type='l',
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xlab="",ylab='',
     main="",
     ylim=c(-0.25,0.25))
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=2, line=4,font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=3)
mtext("In the final trials, scaled trial order = 1.5, 1st Block", side = 3, line = -2, outer = TRUE,font=3)
mtext("difference in estimated Log RT", side = 2, line=-2.5, outer = TRUE, font=3)
#mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# # 2.(2)the responses times to the less similar translation equivalents decrease with the accumulation of trials
# par(mfrow=c(2,1))
# # JNfirst_BJ
# par(mar=c(1.5,3,4,3)) #bottom,left,top, right
# slice_JNfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_first','BJ_NA')),
#                                  cond=list(meanSimi.crl=-1,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_JNfirst_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_JNfirst_BJ$difference+slice_JNfirst_BJ$CI),rev(slice_JNfirst_BJ$difference-slice_JNfirst_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("JM", side=4, line=0.5,font = 2)
# # SCfirst_BJ
# par(mar=c(4,3,1,3))
# slice_SCfirst_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_first','BJ_NA')),
#                                  cond=list(meanSimi.crl=-1,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_SCfirst_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_SCfirst_BJ$difference+slice_SCfirst_BJ$CI),rev(slice_SCfirst_BJ$difference-slice_SCfirst_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("SC", side=4, line=0.5,font =2)
# mtext("Bilinguals' Responses to tonal similarity and trial order", side = 3, line = -1, outer = TRUE,font=2)
# mtext("To the least similar translation equivalents, scaled similarity = -1,1st Block", side = 3, line = -2, outer = TRUE,font=2)
# mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
# mtext("scaled trial order (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)
# # 2nd block
# par(mfrow=c(2,1))
# # JNsecond_BJ
# par(mar=c(1.5,3,4,3)) #bottom,left,top, right
# slice_JNsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
#                                   cond=list(meanSimi.crl=-1.5,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("JM", side=4, line=0.5,font = 2)
# # SCsecond_BJ
# par(mar=c(4,3,1,3))
# slice_SCsecond_BJ= get_difference(m_7c,cond1=list(Lanmod_Block='SC_second'),
#                                   cond2=list(Lanmod_Block='BJ_NA'),
#                                   cond=list(meanSimi.crl=-1.5,Trial.crl=seq(-1.5,1.5,length=100),WFreq="h"))
# plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
#      type='l',xlab="",
#      main="",
#      ylab="",
#      ylim=c(-0.25,0.25))
# polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
#         c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
#         col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
# mtext("SC", side=4, line=0.5,font =2)
# mtext("Bilinguals' Responses to tonal similarity and trial order", side = 3, line = -1, outer = TRUE,font=2)
# mtext("To the least similar translation equivalents, scaled similarity = -1.5,2nd Block", side = 3, line = -2, outer = TRUE,font=2)
# mtext("difference in estimated Log RT", side = 2, line=-1, outer = TRUE, font=2)
# mtext("scaled trial order (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# 3. The second block
# (1) Tested in the non-dominant language JM, the sensitivity to interlingual tonal similarity is lost after switching 
# (2) Tested in the dominant language SC, trial-independent discontinuous response to tonal similarity emerged 
par(mfrow=c(2,1))
# JNsecond_BJ
par(mar=c(1.5,2,4,4)) #bottom,left,top, right
slice_JNsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('JN_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_JNsecond_BJ$difference,
     type='l',
     main="",
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,xaxt="n",yaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
axis(4,cex.axis=1.5)
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_JNsecond_BJ$difference+slice_JNsecond_BJ$CI),rev(slice_JNsecond_BJ$difference-slice_JNsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("2nd Block", side=3, line=0.5,font = 2)
mtext("JM", side=4, line=3,font = 2)
# SCsecond_BJ
par(mar=c(4,2,1,4))
slice_SCsecond_BJ= get_difference(m_7c,comp=list(Lanmod_Block=c('SC_second','BJ_NA')),
                                  cond=list(meanSimi.crl=seq(-1.5,2,length=100),Trial.crl=1.5,WFreq="h"))
plot(seq(-1.5,2,length=100),slice_SCsecond_BJ$difference,
     type='l',
     main="",
     labcex = 1.5,add.color.legend = FALSE, cex.main = 1.5,ticktype='detailed', cex.axis = 1.5, cex.lab = 1.5,yaxt="n",xlab="",ylab='',
     ylim=c(-0.25,0.25))
axis(4,cex.axis=1.5)
polygon(c(seq(-1.5,2,length=100),rev(seq(-1.5,2,length=100))),
        c((slice_SCsecond_BJ$difference+slice_SCsecond_BJ$CI),rev(slice_SCsecond_BJ$difference-slice_SCsecond_BJ$CI)),
        col=rgb(0.25,0.25,0.25,alpha=.25),border=NA,ylim=c(-0.25,0.25))
mtext("SC", side=4, line=3,font =2)
mtext("Bilinguals' Responses - Monolinguals' Responses", side = 3, line = -1, outer = TRUE,font=3)
mtext("In the final trials, scaled trial order = 1.5, 2nd Block", side = 3, line = -2, outer = TRUE,font=3)
mtext("difference in estimated Log RT", side = 2, line=-0.8, outer = TRUE, font=3)
#mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=2)

# difference due to frequency
par(mfrow=c(1,3))
par(mar=c(3,3.2,4,2.8))
plot_smooth(m_7c, view='meanSimi.crl', cond=list(WFreq="h"),
            col='grey',main="High Word Freq.",ylim=c(6.6,7),
            rm.ranef=TRUE)
par(mar=c(3,3,4,3))
plot_smooth(m_7c, view='meanSimi.crl', cond=list(WFreq="l"),
            col='grey',main="Low Word Freq.",ylim=c(6.6,7),
            rm.ranef=TRUE)
par(mar=c(3,3,4,3))
plot_diff(m_7c, view='meanSimi.crl',
          comp=list(WFreq=c("h","l")),
          ylim=c(-0.2,0.2),
          main="High Freq. - Low Freq.") 
mtext("Estimated Log RT", side = 2, line=-1.5, outer = TRUE, font=3)
mtext("scaled similarity (z-transformed)", side = 1, line=-1, outer = TRUE, font=3)



# 1.common in all conditions: 
# (1) at the beginning of the block, the increase of similarity facilitates lexical access
# (2) the responses times to the most similar (nearly identical) translation equivalents increase with the accumulation of trials
# 2. JM and SC common in the first blocks:
# The effect of tonal similarity effect reverses with the increase of trials
# *the responses times to the less similar translation equivalents decrease with the accumulation of trials
# 3. the second block
# (1) restoration of continuity in the non-dominant dialect JM 
# (2) emergence of trial-independent discontinuity in the non-dominant dialect SC
# # (7b)Try replacing Trial.general.crl with Trial.crl (only in the random smooths)
# m_7b = bam(LogRT ~ s(meanSimi.crl, by=Lanmod_Block)
#            +s(meanSimi.crl,by=WFreq) 
#            +Lanmod_Block+WFreq
#            +s(meanSimi.crl,participant,bs='fs',m=1)
#            +s(Trial.crl,StimuliID,bs='fs',m=1),
#            data=data.prumed.bothgroups, gc.level=2, method='ML')
# summary(m_7b)
# AIC(m_5c)-AIC(m_7b) # only different from 5c in the use of Trial.crl
# AIC(m_6d)-AIC(m_7b) # 6d use Trial.crl instead of Trial.general.crl
# compareML(m_5c,m_7b)
# 
# Error in gam.fit3(x = X, y = y, sp = L %*% lsp1 + lsp0, Eb = Eb, UrS = UrS,  : 
#                     'Calloc' could not allocate memory (3108169 of 8 bytes)
#                   In addition: Warning messages:
#                     1: In te(meanSimi.crl, d = c(1, 1), by = Lanmod_Block) :
#                     something wrong with argument d.
#                   2: In gam.fit3(x = X, y = y, sp = L %*% lsp1 + lsp0, Eb = Eb, UrS = UrS,  :
#                                    Reached total allocation of 3909Mb: see help(memory.size)
#                                  3: In gam.fit3(x = X, y = y, sp = L %*% lsp1 + lsp0, Eb = Eb, UrS = UrS,  :
#                                                   Reached total allocation of 3909Mb: see help(memory.size)

#(8a) Try adding meanScaleStyle (to 5c, only in the fixed smooths)
m_8a = bam(LogRT ~ te(meanSimi.crl,meanScaleStyle, d=c(1,1),by=Lanmod_Block)
           +s(meanSimi.crl,by=WFreq) 
           +Lanmod_Block+WFreq
           +s(meanSimi.crl,participant,bs='fs',m=1)
           +s(StimuliID, bs = "re"),
           data=data.prumed.bothgroups, gc.level=2, method='ML')
summary(m_8a)
AIC(m_5c)-AIC(m_8a) # only different from 5c in the use of meanScaleStyle
AIC(m_6c)-AIC(m_8a) # 6c has Trial.general.crl instead of meanScaleStyle
# m_5c & m_6c better